#!/bin/bash
# -*- encoding: utf-8 -*-
# Nokinux main script
# 
# Copyright (C) 2008-2009 Davide Pica
# Copyright (C) 2009 Daniele Napolitano
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

install_path=`whereis -b nokinux | sed 's/nokinux: \(.*\)\/bin\/nokinux/\1/'`

# Internazionalization
TEXTDOMAIN="nokinux"
export TEXTDOMAIN
TEXTDOMAINDIR="$install_path/share/locale"
export TEXTDOMAINDIR

# Load strings
source "$install_path"/share/nokinux/strings

# Check for Zenity presence
which zenity
if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]; then
	zenity --info --text="$zenity_not_installed" --title="$zenity_not_installed_TITLE"
exit 1
fi

title="Nokinux Pre Alpha 0.0.8.5 Script"
user=`whoami`
log_apt="$HOME/.nokinux/nokinux_log_apt"
log_install="$HOME/.nokinux/nokinux_log_install"

#language=`echo $LANG | cut -d "." -f 1`
#language=""
#pass=""

if [ ! -e "$HOME/.nokinux" ]; then
    mkdir "$HOME/.nokinux"
fi


#function GetRoot {
#if [ "$pass" == "" ]
#then
#        pass=`zenity --entry --hide-text --text="$text_pass" --title="$title"`
#
#        if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 1 ]
#            then
#                zenity --question --text="$exit_conferm" --title="$title"
#                if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 0 ]
#                        then
#                                exit
#                        else
#                                GetRoot
#                                exit
#                fi
#        fi
#
#        echo "$pass" | sudo -S -l

#        if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 2` -ne 0 ]
#                then
#                        pass=""
#                        zenity --warning --title="$title" --text="$repeat_pass"
#                        GetRoot
#
 #       fi
#fi
#}

function AddCell {

zenity --info --text="$connect_cell" --title="$title"

lsusb | grep Nokia

if [ $? -eq 0 ];
 then
       echo "$connect_succ"
 else

until [ $? -eq 0 ]
do
        zenity --question --text="$connect_unsucc" --title="$title"
        if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                then
                        #sudo -k
                       Start
                       exit
       fi

       lsusb | grep Nokia
done
fi
idVendor=`lsusb | grep Nokia | cut -d: -f2| cut -d" " -f3`
idProduct=`lsusb | grep Nokia | cut -d: -f3| cut -d" " -f1`

GetRoot

gksu "cp /etc/udev/rules.d/40-permissions.rules $HOME/.nokinux/"
stringa='BUS=="usb", SYSFS{idVendor}=="'$idVendor'", SYSFS{idProduct}=="'$idProduct'", GROUP="dialout"'
gksu "echo $stringa >> $HOME/.nokinux/40-permissions.rules"

da_inserire=$stringa

controlla ()
{
cat /etc/udev/rules.d/40-permissions.rules | while read linea;
   do  {
       if [ "$1" == "$linea" ]
           then
               return 1
       fi
       }
   done
}
controlla "$da_inserire"
if [ $? -eq 1 ]
   then
      echo "$connect_installed"
   else
      echo ""$connect_not_installed
gksu "cp $HOME/.nokinux/40-permissions.rules /etc/udev/rules.d/"

       gksu "chgrp fuse /bin/fusermount" && gksu "chmod u+s /bin/fusermount" && gksu "adduser $USER fuse"

       gksu "/etc/init.d/udev restart"
       touch $HOME/.nokinux/NokiaInstalled
       echo status="installed" >> $HOME/.nokinux/NokiaInstalled
fi
}

function Mount {

       if [ -d $HOME/Nokia ];
        then
               obexfs -u 1 $HOME/Nokia
        else
               mkdir $HOME/Nokia
               obexfs -u 1 $HOME/Nokia
       fi
zenity --question --text="$mount_open" --title="$title"
               if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 0 ]
                  then
                      pcmanfm $HOME/Nokia
               fi
zenity --question --text="$mount_umount" --title="$title"
               if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 0 ]
                  then
                      Umount
                      echo "$mount_unmonted"
                      Start
                  else
                      Start
                    fi
}

function Umount {
    gksu "fusermount -u $HOME/Nokia "
         if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                               then
                                      echo "$now_not_mounted_nokia"
         fi
}


function Modem {
       nm-connection-editor
}


function Start {
       choose=`zenity  --height=400 --width=380 --title="$menu_title" --text="$menu_text" --list --column="$menu_list_column" "$menu_mount" "$menu_umount" "$menu_addcell" "$menu_modem" "$menu_manual_addcell" "$menu_uninstall" "$menu_backup_restore" "$menu_language" "$menu_info" "$menu_exit"`

       case "$choose" in
          "$menu_mount")
               AddCell
               Mount
               Start
               ;;
          "$menu_umount")
               Umount
               Start
               ;;
          "$menu_addcell")
               AddCell
               Start
               ;;
          "$menu_modem")
               zenity --info --text="$modem_info" --title="$modem_info_title"
               Modem
               Start
               ;;
          "$menu_manual_addcell")
               gksu "gedit /etc/udev/rules.d/40-permissions.rules"
               Start
               ;;
          "$menu_uninstall")
               zenity --question --text="$uninstall_conferm" --title="$uninstall_conferm_title"
               if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                  then
                       Start
                  else
                # E se questi pachetti erano stati installati in precedenza?
                #gksu "apt-get remove -y openobex-apps libopenobex1 obexftp bwidget obexfs pcmanfm tree 2> $log_apt" 2>&1 | zenity --text-info --width 600 --height 500
       gksu "rm -rf $HOME/.nokinux"
       gksu "rm -rf $install_path/share/nokinux"
       gksu "rm -rf $install_path/share/applications/nokinux.desktop"
       gksu "rm -rf $install_path/share/icons/hicolor/96x96/apps/nokinux.png"
	 zenity --info --text="Disinstallazione completata! Ora uscirai dal programma."
                exit 0
                    fi

               ;;
  "$menu_backup_restore")
               zenity --info --text="$backup_warning" --title="$title"
               backup
               Start
               ;;
          "$menu_language")
               ChooseLanguage
               Start
               ;;
          "$menu_info")
               zenity --info --text="$info_team" --title="$title"
               zenity --question --text="$info_site" --title="$title"
               if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 0 ]
                  then
                     xdg-open "http://www.nokinux.it"
               fi

               Start
               ;;
           "$menu_exit")
               zenity --question --text="$exit_conferm" --title="$title"
               if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 0 ]
                  then
                      Umount
                      exit 0
                  else
                      Start
                    fi
               ;;
esac
}

function backup {
       choose=`zenity  --height=400 --width=380 --title="$menu_title" --text="$menu_text" --list --column="$menu_list_column_backup" "$backup_C" "$backup_E" "$restore_C" "$restore_E" "$come_back"`

       case "$choose" in
          "$backup_C")
               if [ -d $HOME/Nokia ];
                    then
               obexfs -u 1 $HOME/Nokia
                    else
               mkdir $HOME/Nokia
               obexfs -u 1 $HOME/Nokia
               fi
               cartella_scelta=`zenity --file-selection --title="$backup_directory" --directory --filename=$HOME/`
               # prende il valore di ritorno del comando precedente
               ritorno=$?
               # controlla se si è premuto OK o Annulla
               if [ "$ritorno" -ne 0 ]; then
               # è stato premuto annulla o chiusa la finestra
                   zenity --warning --title="$backup_stopped" --text="$backup_aborted"
               backup
               fi
               nome_backup=`zenity --entry --text="$backup_file_name" --title="$backup_file_name_title"`
               zenity --info --title="$backup_directory_select_title" --text="$backup_directory_select"
               cd $cartella_scelta
               tar cvzPf "${nome_backup}.tar.gz" "$HOME/Nokia/C:" | zenity --progress --pulsate --text="$backup_create_C"  --title="$backup_read_memory" --auto-close
               zenity --info --text="$backup_ok" --title="$title"
               fusermount -u $HOME/Nokia
         if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                               then
                                      echo "$now_not_mounted_nokia"
         fi
               backup
               ;;
          "$backup_E")
                if [ -d $HOME/Nokia ];
                    then
               obexfs -u 1 $HOME/Nokia
                    else
               mkdir $HOME/Nokia
               obexfs -u 1 $HOME/Nokia
               fi
               cartella_scelta=`zenity --file-selection --title="$backup_directory" --directory --filename=$HOME/`
               # prende il valore di ritorno del comando precedente
               ritorno=$?
               # controlla se si è premuto OK o Annulla
               if [ "$ritorno" -ne 0 ]; then
               # è stato premuto annulla o chiusa la finestra
                   zenity --warning --title="$backup_stopped" --text="$backup_aborted"
               backup
               fi
               nome_backup=`zenity --entry --text="$backup_file_name" --title="$backup_file_name_title"`
               zenity --info --title="$backup_directory_select_title" --text="$backup_directory_select"
               cd $cartella_scelta
               tar cvzPf "${nome_backup}.tar.gz" "$HOME/Nokia/E:" | zenity --progress --pulsate --text="$backup_create_E"  --title="$backup_read_memory" --auto-close
               zenity --info --text="$backup_ok" --title="$title"
               fusermount -u $HOME/Nokia
         if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                               then
                                      echo "$now_not_mounted_nokia"
         fi
               backup
               ;;
         "$restore_C")
               if [ -d $HOME/Nokia ];
                    then
               obexfs -u 1 $HOME/Nokia
                    else
               mkdir $HOME/Nokia
               obexfs -u 1 $HOME/Nokia
               fi
               file_backup=`zenity --file-selection --title="$find_backup_file" --filename=$HOME/`
               tar xvzPf $file_backup -C "$HOME/Nokia/C:" | zenity --progress --pulsate --text="$restore_now_C"  --title="$restore_read_memory" --auto-close
               zenity --info --text="$restore_ok" --title="$title"
               fusermount -u $HOME/Nokia
         if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                               then
                                      echo "$now_not_mounted_nokia"

         fi
               backup
               ;;
          "$restore_E")
               if [ -d $HOME/Nokia ];
                    then
               obexfs -u 1 $HOME/Nokia
                    else
               mkdir $HOME/Nokia
               obexfs -u 1 $HOME/Nokia
               fi
               file_backup=`zenity --file-selection --title="$find_backup_file" --filename=$HOME/`
               tar xvzPf $file_backup -C "$HOME/Nokia/E:" | zenity --progress --pulsate --text="$restore_now_E"  --title="$restore_read_memory" --auto-close
               zenity --info --text="$restore_ok" --title="$title"
               fusermount -u $HOME/Nokia
         if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -ne 0 ]
                               then
                                      echo "$now_not_mounted_nokia"

         fi
               backup
               ;;
           "$come_back")
               Start
           ;;
       esac
              if [ `echo ${PIPESTATUS[*]} | cut -d " " -f 1` -eq 1 ]
                  then
                      Start
                  else
                      backup

                    fi

}


# Visualizzazione del logo!
python "$install_path"/share/nokinux/splash.py
    
# Avvio del programma vero e proprio
Start
